/***************************************************************************
                          myconfig.h  -  description
                             -------------------
    begin                : Tue Oct 9 2001
    copyright            : (C) 2001 by Fredrik Srensson
    email                : sorn73@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MYCONFIG_H
#define MYCONFIG_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// System includes
#include <iostream>

// Project includes
#include "ldapctrldlg.h"

// QT includes
#include <qwidget.h>
#include <qlineedit.h>
#include <qtextstream.h>
#include <qlistview.h>
#include <qcombobox.h>
#include <qlistbox.h>
#include <qcheckbox.h>

// KDE includes
#include <ksimpleconfig.h>
#include <kmessagebox.h>
#include <klocale.h>

#define LAMEMAX 20

class myconfig : public ldapctrldlg {
  Q_OBJECT

	  public:
    /** construtor */
	    myconfig(QWidget* parent=0, const char *name=0,bool modal=false,WFlags fl=0);
	
    /** destructor */
	    ~myconfig();

		public slots:

		private:
			KSimpleConfig *workConf;
			bool entryUpdate;

			QString lastserver;

			void buildServList(QString & inServer );
			void loadServer(QString & inServer);
			void saveServer(QString & inServer);
			void initServers();
			void setDefaultScheme();
			void clearEntry();
			int kabtagNum(QString instr);
			int saveServerList();

		private slots:

			void accept();
			void slot_deleteServer();
			void slot_addServer();
			void slot_newServer();
			void slot_selSchemeEntry();
			void slot_deleteEntry();
			void slot_addEntry();
			void slot_updateLdapattr();
			void slot_updateKabtag();
			void slot_updateHeading();
			void slot_up();
			void slot_down();

};


#endif

