/***************************************************************************
                          myldapklient.h  -  description
                             -------------------
    begin                : Mon Sep  3 19:35:50 CEST 2001
    copyright            : (C) 2001 by fsn
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MYLDAPKLIENT_H
#define MYLDAPKLIENT_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// System includes
#include <iostream>

// Project includes
#include "ldapdlg.h"
#include "myconfig.h"

// QT includes
#include <qwidget.h>
#include <qlineedit.h>
#include <qtextstream.h>
#include <qlistview.h>
#include <qcombobox.h>
#include <qtextcodec.h>
#include <qclipboard.h>

// KDE includes
#include <kabc/stdaddressbook.h>
#include <kapp.h>
#include <ksimpleconfig.h>
#include <kmessagebox.h>
#include <klocale.h>
#include <kprocess.h>
#include <kpassdlg.h>
#include <kpopupmenu.h>

// LDAP includes

extern "C" {
	#include <ldap.h>
	#include <sys/time.h>
}


/** MyldapKlient is the base class of the project */
// Almost just the template.

#define LAMEMAX 20

class MyldapKlient : public ldapdlg {
  Q_OBJECT 
  public:
    /** constructor */
    MyldapKlient(QWidget* parent=0, const char *name=0);
	
    /** destructor */
    ~MyldapKlient();

	private slots:
		virtual void slot_doLdapSearch() ;
		virtual void slot_addToKab();
		virtual void slot_serverChanged();
		virtual void slot_configure();
		virtual void slot_mailto();
    virtual void slot_toClipboard();
    virtual void slot_RMB( QListViewItem* Item, const QPoint & point, int );

	private:
		QList<QString> schemeList;
		QList<QString> kabentryList;
	
		KSimpleConfig *config;
    KPopupMenu *popUp;
		
		int getSchemePos(QString &thisScheme);
		QString getKabentryTag(int thisCol);
		QString getSchemeAttr(int thisCol);

    QCString knownPass;

		void newServer(QString server);
		void buildServerComboBox(QString & inServer);
		void init();
		void buildAllSearchAttrCombo(QString & inServer);
		void buildSearchAttrCombo(QComboBox * inCombo, QString & inServer, int selected);

};

#endif
